import java.util.*;
import java.io.*;

public class AnalyseGraphs {

    static void readDIMACS(String fname) throws IOException {
	int[] degree;   // degree of vertices
	int[][] A;      // 0/1 adjacency matrix
	int n;
	String s = "";
	Scanner sc = new Scanner(new File(fname));
	while (sc.hasNext() && !s.equals("p")) s = sc.next();
	sc.next();
	n      = sc.nextInt();   
	int m  = sc.nextInt();   
	degree = new int[n];
	A      = new int[n][n];
	while (sc.hasNext()){
	    s     = sc.next(); // skip "edge"
	    int i = sc.nextInt() - 1;
	    int j = sc.nextInt() - 1; 
	    degree[i]++; degree[j]++;
	    A[i][j] = A[j][i] = 1;
	}
	sc.close();
	int edges = 0;
	for (int i=0;i<n-1;i++)
	    for (int j=i+1;j<n;j++)
		edges = edges + A[i][j];
	double p = (double)edges/(double)(n*(n-1)/2);
	System.out.format("%d %d %.2f  ",n,edges,p);
	System.out.println();
    }

    public static void main(String[] args) throws IOException {
	int n          = Integer.parseInt(args[0]); // vertices in a graph
	int pLo        = Integer.parseInt(args[1]); // edge probability
	int pHi        = Integer.parseInt(args[2]); // edge probability
	int pInc       = Integer.parseInt(args[3]); // increment for p
	int lwb        = Integer.parseInt(args[4]); // index of 1st results file
	int upb        = Integer.parseInt(args[5]); // index of last results file
	String fname   = "";

	for (int p=pLo;p<=pHi;p=p+pInc)
	    for (int i=lwb;i<=upb;i++){
		if (i < 10)
		    fname = "../randomData/"+ n +"-"+ p +"-0"+ i +".txt";
		else
		    fname = "../randomData/"+ n +"-"+ p +"-"+ i +".txt";
		readDIMACS(fname);
	    }
    }
}
