import java.util.*;

public class MCCol extends MC {
    ArrayList[] colourClass;

    MCCol (int n,int[][] A,int[] degree, int style) {
	super(n,A,degree, style);
    }

    void search() {
	colourClass                          = new ArrayList[n];
	for (int i=0;i<n;i++) colourClass[i] = new ArrayList<Integer>(n);
	super.search();
    }

    void expand(ArrayList<Integer> C,ArrayList<Integer> P){
	if (timeLimit > 0 && System.currentTimeMillis() - cpuTime >= timeLimit) return;
	nodes++;
	for (int i=P.size()-1;i>=0;i--){
	    if (C.size() + P.size() <= maxSize) return;
	    int v = P.get(i);
	    C.add(v);
	    ArrayList<Integer> newP = new ArrayList<Integer>(i);
	    for (int j=0;j<=i;j++){
		int w = P.get(j);
		if (A[v][w] == 1) newP.add(w);
	    }
	    if (newP.isEmpty() && C.size() > maxSize) saveSolution(C);
	    if (!newP.isEmpty())
		if (colourBound(newP, Math.max(0, maxSize - C.size())))
			expand(C,newP);
	    C.remove(C.size()-1);
	    P.remove(i);
	}
    }

    boolean colourBound(ArrayList<Integer> P, int target) {
	if (P.size() <= target) return false;
	int colours = 0;
	int m = P.size();
	for (int i=0;i<target;i++) colourClass[i].clear();
	for (int i=0;i<m;i++){
	    int v = P.get(i);
	    int k = 0;
	    while (conflicts(v,colourClass[k])) k++;
	    colourClass[k].add(v);
	    colours = Math.max(colours,k+1);
	    if (colours > target) return true;
	}
	return false;
    }

    boolean conflicts(int v,ArrayList<Integer> colourClass){
	for (int i=0;i<colourClass.size();i++){
	    int w = colourClass.get(i);
	    if (A[v][w] == 1) return true;
	}
	return false;
    }
}

