import java.util.*;

public class MCColPivot extends MCCol {
    int pivotStyle; // 0 first, 1 last, 2 minDegree, 3 maxDegree

    MCColPivot (int n,int[][] A,int[] degree, int style, int pivotStyle) {
	super(n,A,degree, style);
	this.pivotStyle = pivotStyle;
    }

    int getPivot(ArrayList<Integer> P) {
	if (2 == pivotStyle || 3 == pivotStyle) {
	    int goal = -1, result = 0;
	    for (int i=P.size()-1;i>=0;i--){
		int degree = 0;
		for (int j=0;j<P.size();j++) if (A[P.get(i)][P.get(j)] == 1) ++degree;
		if (-1 == goal ||
			(pivotStyle == 2 && degree < goal) ||
			(pivotStyle == 3 && degree > goal)) {
		    goal = degree;
		    result = i;
			}
	    }
	    return P.get(result);
	}
	else if (1 == pivotStyle)
	    return P.get(P.size() - 1);
	else
	    return P.get(0);
    }

    void expand(ArrayList<Integer> C,ArrayList<Integer> P){
	if (timeLimit > 0 && System.currentTimeMillis() - cpuTime >= timeLimit) return;
	// log(nodes, C.size(), P.size(), maxSize);
	nodes++;
	int pivot = getPivot(P);
	//System.out.println(pivot +" "+ C +" "+ P);
	for (int i=P.size()-1;i>=0;i--){
	    int v = P.get(i);
	    if (0 == A[v][pivot]) {
		if (C.size() + P.size() <= maxSize) return;
		C.add(v);
		ArrayList<Integer> newP = new ArrayList<Integer>(i);
		for (int j=0;j<P.size();j++){
		    int w = P.get(j);
		    if (A[v][w] == 1) newP.add(w);
		}
		if (newP.isEmpty() && C.size() > maxSize) saveSolution(C);
		if (!newP.isEmpty())
		    if (colourBound(newP, Math.max(0, maxSize - C.size())))
			    expand(C,newP);
		C.remove(C.size()-1);
		P.remove(i);
	    }
	}
    }
}

