import java.util.*;
//
// Simple MC, select vertex of maximum degree
//

public class MCMax extends MC {
    ArrayList[] colourClass;

    MCMax (int n,int[][] A,int[] degree, int style) {
	super(n,A,degree,-1);
    }

    void search() {
	colourClass                          = new ArrayList[n];
	for (int i=0;i<n;i++) colourClass[i] = new ArrayList<Integer>();
	super.search();
    }

    void expand(ArrayList<Integer> C,ArrayList<Integer> P){
	if (timeLimit > 0 && System.currentTimeMillis() - cpuTime >= timeLimit) return;
	nodes++;
	int m = P.size();
	while(C.size() + P.size() > maxSize){
	    int v = P.get(m-1);
	    C.add(v);
	    ArrayList<Integer> newP = new ArrayList<Integer>(m);
	    for (int j=0;j<m;j++){
		int w = P.get(j);
		if (A[v][w] == 1) newP.add(w);
		adjacency++;
	    }
	    if (newP.isEmpty() && C.size() > maxSize) saveSolution(C);
	    if (colourBound(newP, Math.max(0, maxSize - C.size()))) expand(C,newP);
	    C.remove(C.size()-1);
	    P.remove(m-1);
	    m--;
	}
    }

    boolean colourBound(ArrayList<Integer> P, int target) {
	if (P.size() <= target){fails++; return false;}
	int colours = 0;
	int m = P.size();
	colourings = colourings + m;
	for (int i=0;i<target;i++) colourClass[i].clear();
	for (int i=m-1;i>=0;i--){
	    int v = P.get(i);
	    int k = 0;
	    while (conflicts(v,colourClass[k])) k++;
	    colourClass[k].add(v);
	    colours = Math.max(colours,k+1);
	    if (colours > target) return true;
	}
	return false;
    }

    boolean conflicts(int v,ArrayList<Integer> colourClass){
	for (int i=0;i<colourClass.size();i++){
	    comparisons++;
	    int w = colourClass.get(i);
	    adjacency++;
	    if (A[v][w] == 1) return true;
	}
	return false;
    }
}

