import java.util.*;

class MCQTomita extends MCQ {

    MCQTomita (int n,int[][]A,int[] degree,int style) {
	super(n,A,degree,style);
    }

    void search(){
	cpuTime                              = System.currentTimeMillis();
	nodes                                = 0;
	colourClass                          = new ArrayList[n];
	ArrayList<Integer> C                 = new ArrayList<Integer>(n);
	ArrayList<Integer> P                 = new ArrayList<Integer>(n);
	for (int i=0;i<n;i++) colourClass[i] = new ArrayList<Integer>(n);
	orderVertices(P);
	int[] colour = new int[P.size()];
	int maxDeg = degree[P.get(0)];
	for (int i=0;i<maxDeg;i++) colour[i] = i+1;
	for (int i=maxDeg;i<n;i++) colour[i] = maxDeg+1;
	expand(C,P,colour);
    }

    void expand(ArrayList<Integer> C,ArrayList<Integer> P,int[] colour){
	if (timeLimit > 0 && System.currentTimeMillis() - cpuTime >= timeLimit) return;
	nodes++;
	int m = P.size();
	for (int i=m-1;i>=0;i--){
	    if (C.size() + colour[i] <= maxSize) return;
	    int v = P.get(i);
	    C.add(v);
	    ArrayList<Integer> newP = new ArrayList<Integer>(i);
	    for (int j=0;j<=i;j++){
		int u = P.get(j);
		if (A[u][v] == 1) newP.add(u);
	    }
	    if (newP.isEmpty() && C.size() > maxSize) saveSolution(C);
	    if (!newP.isEmpty()){
		int[] newColour = new int[newP.size()];
		numberSort(C,newP,newP,newColour);
		expand(C,newP,newColour);
	    }
	    C.remove(C.size()-1);
	    P.remove(i);
	}
    }
}
