import java.util.*;
import java.io.*;

class MCSaDist extends MCSa {

    MCSaDist (int n,int[][]A,int[] degree,int style) {
	super(n,A,degree,style);
    }

    void search(int omit,int include){
	cpuTime                              = System.currentTimeMillis();
	nodes                                = 0;
	colourClass                          = new ArrayList[n];
	ArrayList<Integer> C                 = new ArrayList<Integer>(n);
	ArrayList<Integer> ColOrd            = new ArrayList<Integer>(n);
	for (int i=0;i<n;i++) colourClass[i] = new ArrayList<Integer>(n);
	orderVertices(ColOrd);
	for (int i=0;i<omit;i++) ColOrd.remove(ColOrd.size()-1);
	for (int i=0;i<include;i++){
	    int v = ColOrd.get(ColOrd.size()-1);
	    C.add(v);
	    ArrayList<Integer> newColOrd = new ArrayList<Integer>(n);
	    for (int w : ColOrd) if (A[v][w] == 1) newColOrd.add(w);
	    expand(C,new ArrayList<Integer>(n),newColOrd,n,null,null,new int[]{});
	    C.remove((Integer)v);
	    ColOrd.remove((Integer)v);
	}
    }
    //
    // remove from the right end of ColOrd "omit" number of vertices
    // iterate from the right end of ColOrd "include" number of vertices
    //

    static int[] degree;   // degree of vertices
    static int[][] A;      // 0/1 adjacency matrix
    static int n;

    static void readDIMACS(String fname) throws IOException {
	String s = "";
	Scanner sc = new Scanner(new File(fname));
	while (sc.hasNext() && !s.equals("p")) s = sc.next();
	sc.next();
	n      = sc.nextInt();   
	int m  = sc.nextInt();   
	degree = new int[n];
	A      = new int[n][n];
	while (sc.hasNext()){
	    s     = sc.next(); // skip "edge"
	    int i = sc.nextInt() - 1;
	    int j = sc.nextInt() - 1; 
	    degree[i]++; degree[j]++;
	    A[i][j] = A[j][i] = 1;
	}
	sc.close();
    }

    public static void main(String[] args)  throws IOException {

	readDIMACS(args[0]);
	int style   = Integer.parseInt(args[1]);
	int omit    = Integer.parseInt(args[2]);
	int include = Integer.parseInt(args[3]);
	MCSaDist mc = new MCSaDist(n,A,degree,style);
	System.gc();
	if (args.length > 4) mc.timeLimit = 1000 * (long)Integer.parseInt(args[4]);
	long cpuTime = System.currentTimeMillis();
	mc.search(omit,include);
	//for (int i=0;i<n;i++) mc.search(i,1);
	cpuTime = System.currentTimeMillis() - cpuTime;
	System.out.println(mc.maxSize +" "+ mc.nodes +" "+ cpuTime);
	for (int i=0;i<mc.n;i++) if (mc.solution[i] == 1) System.out.print(i+1 +" ");
	System.out.println();
    }
}
