public class MakeSmallWorldData {

    public static void makeJob(int n,int k,double p,int m) {
	int p100 = (int)(p*100.0);
	String s = "-";
	if (p100 < 10) s = "-0";
	for (int i=0;i<m;i++){
	    System.out.format("graphgen -g:w -n:%d -k:%d -p:%.2f ",n,k,p);
	    System.out.print("-o:../SNAP_smallWorld/"+ n +"-"+ k + s + p100 +"-");
	    if (i<10) System.out.print("0");
	    System.out.println(i +".txt");
	}
    }

    public static void main(String[] args) {
	int n       = Integer.parseInt(args[0]);   // vertices in a graph
	int kLo     = Integer.parseInt(args[1]);   // starting degree
	int kHi     = Integer.parseInt(args[2]);   // ending degree
	int kInc    = Integer.parseInt(args[3]);   // increment
	double pLo  = Double.parseDouble(args[4]); // starting probability
	double pHi  = Double.parseDouble(args[5]); // ending probability
	double pInc = Double.parseDouble(args[6]); // p increment
	int m       = Integer.parseInt(args[7]);   // number of graphs at each setting

	double p = pLo;       
	for (int i=0;p<=pHi+(pInc/2.0);i++){
	    for (int k=kLo;k<=kHi;k=k+kInc) makeJob(n,k,p,m);
	    p = p + pInc;
	}
    }
}
