import java.util.*;
import java.io.*;

public class MakeSmallWorldJob{

    public static void makeSmallWorldJob(String alg,int n,int k,double p,int m){
	int p100 = (int)(p*100.0);
	String s = "-";
	if (p100 < 10) s = "-0";
	String fname = n +"-"+ k + s + p100;
	for (int i=0;i<m;i++){
	    System.out.print("java MaxClique "+ alg +" ../SNAP_smallWorld/"+ fname +"-");
	    if (i<10) System.out.print("0");
	    System.out.print(i +".txt > ");
	    System.out.print("../randomResultsJava/"+ alg +"-smallWorld-"+ fname +"-");
	    if (i<10) System.out.print("0");
	    System.out.println(i +".txt ");
	}
    }

    public static void main(String[] args) {
	String alg = args[0];
	int n       = Integer.parseInt(args[1]);   // vertices in a graph
	int kLo     = Integer.parseInt(args[2]);   // starting degree
	int kHi     = Integer.parseInt(args[3]);   // ending degree
	int kInc    = Integer.parseInt(args[4]);   // increment
	double pLo  = Double.parseDouble(args[5]); // starting probability
	double pHi  = Double.parseDouble(args[6]); // ending probability
	double pInc = Double.parseDouble(args[7]); // p increment
	int m       = Integer.parseInt(args[8]);   // number of graphs at each setting

	double p = pLo;       
	for (int i=0;p<=pHi+(pInc/2.0);i++){
	    for (int k=kLo;k<=kHi;k=k+kInc) makeSmallWorldJob(alg,n,k,p,m);
	    p = p + pInc;
	}
    }
}
