import java.util.*;

public class SparseSet {   

    private int[] data;
    private int[] location;
    private int last;
    private int capacity;
    private Stack<Integer> history;

    public SparseSet (int n){
	data     = new int[n];
	location = new int[n];
	last     = -1;
	capacity = n;
	Arrays.fill(data,-1);
	Arrays.fill(location,-1);
	history = new Stack<Integer>();
    }

    public void add(int i) throws SparseSetException {
	//if (i >= capacity || i < 0) throw new SparseSetException("item "+ i +" out of range");
	//if (contains(i)) throw new SparseSetException("item "+ i +" already present");
	last        = last + 1;
	data[last]  = i;
	location[i] = last;
    }

    public void remove(int i){
	//if (i >= capacity || i < 0) throw new SparseSetException("item "+ i +" out of range");
	//if (!contains(i)) throw new SparseSetException("item "+ i +" not present");
	swap(i,data[last]);
	last--;
    }

    private void swap(int i,int j){
	int loc_i         = location[i];
	int loc_j         = location[j];
	location[i]       = loc_j;
	location[j]       = loc_i;
	data[location[i]] = i;
	data[location[j]] = j;
    }

    public int get(int i){
	//if (i < 0 || i > last) throw new SparseSetException("item "+ i +" out of range");
	return data[i];
    }

    public int size(){return last + 1;}
    public boolean isEmpty(){return last == -1;}
    public boolean contains(int i){return 0 <= location[i] && location[i] <= last && data[location[i]] == i;}
    public void push(){history.push(last);}
    public void pop(){last = history.pop();}
}
